##this script allows analysis using Blei, Ng, and Jordan's (2003) spectral
##clustering algorithm

galileo2spectral<- function(affinity, k=10, metric='cosine',...){
 if(metric=='cosine'){
  S <- affinity$cosine
  aff.max<- max(S)
  distance<- 1 - S/aff.max
  }
if(metric=='euclidean' | metric=='manhattan' | metric=='minkowski' | metric=='maximum' | metric=='canberra'){
	data<- affinity$data
      distance<- dist(data, metric)
	distance<- as.matrix(distance)
	}
  
	
  k <- k
  sigma <- max(distance^2)
  spectral<- function(distance, k, sigma=sigma){
	distance<- distance
	sigma<- sigma
	distance<- exp(-(distance^2)/sigma)
	diag(distance)<- 0
	D.mat<- matrix(0, nrow=nrow(distance), ncol=ncol(distance))
	sums<- apply(distance, 1, sum)
	diag(D.mat)<- 1/(sqrt(sums))
	L<- D.mat%*%distance%*%D.mat
	Y<- eigen(L)$vectors[,1:k]
	out<- apply(Y*Y, 1, sum)
	Y<- Y/sqrt(out)
	sol<- kmeans(Y, k)
	return(sol$cluster)
      }
  out <- spectral(distance, k,sigma)
  return(out)
	}



